## elfhash 0~20150806

=== Makefile ===
DESTDIR=
all:
	gcc -c elfhash.c -o elfhash32.o -DELFCLASS=32
	gcc -c elfhash.c -o elfhash64.o -DELFCLASS=64
	gcc -c main.c -o main.o
	gcc -o elfhash main.o elfhash32.o elfhash64.o	
install: all
	mkdir -p $(DESTDIR)/usr/bin
	install -m 0755 elfhash $(DESTDIR)/usr/bin
clean:
	rm -rf *.o elfhash

=== test/Makefile ===
all:
	@gcc -Wl,--hash-style=gnu -shared -o libdll.so hello.c -I/usr/share/openjdk/include -I/usr/share/openjdk/include/linux -fPIC
	@#gcc -Wl,--hash-style=sysv -shared -o libdll.so hello.c -I/usr/share/openjdk/include -I/usr/share/openjdk/include/linux -fPIC
	@gcc -o main main.c -L. -ldll -I/usr/share/openjdk/include -I/usr/share/openjdk/include/linux
	@javac HelloWorld.java
clean:
	@rm -rf libdll.so* main *.class 
run: all
	@echo -e "\e[0;34m## Before elf patch, \e[0;31merror happened\e[0m"
	@java -Djava.library.path=. HelloWorld ||:
	@echo -e "\e[0;34m## Patch elf\e[0m"
	@../elfhash -f Java_helloWorld_SayHello -t Java_HelloWorld_SayHello libdll.so 
	@echo -e "\e[0;34m## After elf patch, expect result is \"Hello\"\e[0m"
	@java -Djava.library.path=. HelloWorld ||:

=== debian/changelog ===
elfhash (0~20150806-0+twolife1) unstable; urgency=low

  * Initial release.

 -- Sébastien Noel <sebastien@twolife.be>  Thu, 09 Nov 2023 18:34:44 +0100

=== debian/control ===
Source: elfhash
Section: utils
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
Standards-Version: 4.6.2
Vcs-Browser: https://github.com/cjacker/elfhash
Vcs-Git: https://github.com/cjacker/elfhash.git

Package: elfhash
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: manipulate hash table of ELF files
 elfhash is a simple utility for manipulating hash table of existing ELF
 executables and libraries. In particular, it can rename symbols
 to new name as same length.

=== debian/watch ===
version=4 
opts="mode=git,pgpmode=none,repack,pretty=0~%cd,compression=xz" \
https://github.com/cjacker/elfhash.git HEAD
